/**
 * JASMINe
 * Copyright (C) 2009 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id: EngineDashboardController.as 4798 2009-08-07 12:30:47Z alitokmen $
 * --------------------------------------------------------------------------
 */

package org.ow2.jasmine.monitoring.eos.rules.enginedashboard.control
{

import com.adobe.cairngorm.control.FrontController;

import org.ow2.jasmine.monitoring.eos.rules.enginedashboard.command.*;
import org.ow2.jasmine.monitoring.eos.rules.enginedashboard.event.*;
import org.ow2.jasmine.monitoring.eos.rules.enginedashboard.model.EngineDashboardModelLocator;
import org.ow2.jasmine.monitoring.eos.rules.enginedashboard.model.domain.EngineDashboardModel;


/**
* Bind a type of command to an action.
* 
* @author Julien Nicoulaud
*/
public class EngineDashboardController extends FrontController
{

    // =========================================================================
    // Initialization
    // =========================================================================

    /**
    * Create an instance of the controller. Commands are initialized here.
    */
    public function EngineDashboardController()
    {
        initialiseCommands();
    }

    /**
    * Add all of the commands to the pool of commands.
    */
    public function initialiseCommands() : void
    {
        // Retrieve the component model
        var model:EngineDashboardModel = 
            EngineDashboardModelLocator.getInstance().engineDashboardModel;
        
        // Register the commands
        this.addCommand(EngineDashboardEvent.UPDATE_ENGINE_STATUS + model.componentID,
        				UpdateEngineStatusCommand);
        this.addCommand(EngineDashboardEvent.START_ENGINE + model.componentID,
                        StartEngineCommand);
        this.addCommand(EngineDashboardEvent.STOP_ENGINE + model.componentID,
                        StopEngineCommand);
    }
}
}
